#!/usr/local/bin/perl

# Whiplash v1.4
# Copyright (c) 1997-2000, Network Dweebs
# All Rights Reserved

use SDBM_File;
use Fcntl;
use strict vars;
use vars qw { %CONFIG @DISALLOWED_CHANNELS %COLORCODE %FORM };
require "ctime.pl";
require ".config";

print "Content-type: text/html\n\n";

$CONFIG{'SUBMITSCRIPT'} = "submit.cgi";
$CONFIG{'SOCKETSCRIPT'} = "nph-dcc.cgi";

%FORM = &ReadParse;

# We need a block of shared memory to pass chat messages back and forth
# between the submitscript and the socket control script
$CONFIG{'IPC_PRIVATE'} = 0;
$CONFIG{'IPC_RMID'} = 0;
$CONFIG{'SIZE_CHAT'}     = 2000;
if ($CONFIG{'USE_SHMEM'}==1) {
 $CONFIG{'KEY_CHAT'} = shmget($CONFIG{'IPC_PRIVATE'}, $CONFIG{'SIZE_CHAT'},
   0777) || die "shmget: $!\n";
}
else { $CONFIG{'KEY_CHAT'} = $$ . time . "a"; } 

# Enter our PID and SHMKEY into the PID Table for Leak Cleanup
do {
 my(%PIDTABLE);
 tie %PIDTABLE, SDBM_File, $CONFIG{'PIDTABLE'}, O_RDWR | O_CREAT, 0644
  || die "tie: $!\n";
 $CONFIG{'PIDTABLE'}{$CONFIG{'KEY_CHAT'}}=$$;
 untie $CONFIG{'PIDTABLE'};
};

$CONFIG{'MORE_URL'} = "IPCKEY=$CONFIG{'KEY_CHAT'}" .
       "&SOCKETKEY=$FORM{'SOCKETKEY'}" .
       "&fixed=$FORM{'fixed'}" .
       "&BROWSER=$FORM{'BROWSER'}" .
       "&BROWSER_VERSION=$FORM{'BROWSER_VERSION'}" .
       "&NICK=$FORM{'NICK'}" .
       "&THEIRNICK=$FORM{'THEIRNICK'}" .
       "&ADDR=$FORM{'ADDR'}" .
       "&PORT=$FORM{'PORT'}";

print <<_HEAD;
<HTML>
<HEAD>
<TITLE>DCC Chat: $FORM{'THEIRNICK'}</TITLE>
</HEAD>
_HEAD

print <<_BODY; 
<FRAMESET ROWS=*,50 FRAMEBORDER=0 FRAMESPACING=0 BORDER=0>

<!-- output window-->
<FRAME NAME="_fmsgs" SRC="$CONFIG{'SOCKETSCRIPT'}?$CONFIG{'MORE_URL'}" SCROLLING="auto">

<!-- input window -->
<FRAME NAME="_fsubmit" SRC="$CONFIG{'SUBMITSCRIPT'}?$CONFIG{'MORE_URL'}" SCROLLING="no">
</FRAMESET>
_BODY

print <<_FOOTER;
</HTML>
_FOOTER

sub ReadParse {
 my(%F, $buffer, @pairs);
 if ($ENV{'REQUEST_METHOD'} =~ /GET/i)
  { @pairs = split(/&/, $ENV{'QUERY_STRING'}); }
 else {
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs = split(/\&/, $buffer);
 }
 foreach(@pairs) {
  my($name, $value) = split(/\=/, $_);

  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/<!--(.|\n)*-->//g;
  $F{$name}=$value;
 }

 return %F;
}
