#!/usr/local/bin/perl

# Whiplash v1.4
# Copyright (c) 1997-2000, Network Dweebs
# All Rights Reserved

# This is an identd encapsulator that can be used to help prevent k-lines
# of your server (for having clones).

# This script should be called by inetd when a connection is made to the
# ident port (113).  Here is a sample line in /etc/inetd.conf....
#
#ident	stream	tcp	nowait	root	/usr/local/irc/identd.pl  identd.pl

use SDBM_File;
use Fcntl;
use strict vars;
use vars qw { %CONFIG @DISALLOWED_CHANNELS %COLORCODE $STDIN %PIDTABLE };
require "pwd.pl";

$CONFIG{'PATH'}="/path/to/whiplash";
chdir($CONFIG{'PATH'}) || die "$CONFIG{'PATH'}: $!";

require ".config";

die "$0: IDENTD NOT PROPERLY SETUP\n" unless (-e "$CONFIG{'IDENTTABLE'}.pag");

$ENV{'PATH'}="/usr/sbin";

$STDIN=<STDIN>;
chomp($STDIN);
$STDIN =~ s/\s+//g;
my($LOCAL, $REMOTE) = split(/\,/, $STDIN);

tie %PIDTABLE, SDBM_File, $CONFIG{'IDENTTABLE'}, O_RDWR | O_CREAT, 0644
  || die "tie: $!\n";

do {
 my($PID, $USERNAME);
 $USERNAME=$PIDTABLE{$LOCAL};
 ($PID, $USERNAME)=split(/\:/, $USERNAME);

 if (!$USERNAME) {
  print "$LOCAL, $REMOTE : ERROR : NO-USER\n";
  exit;
 }

 print "$LOCAL, $REMOTE : USERID : UNIX : $USERNAME\n";
};

foreach(keys(%PIDTABLE)) { 
 my($PID)=split(/\:/, $PIDTABLE{$_});
 if (! kill(0, $PID)) { delete($PIDTABLE{$_}); }
}
untie %PIDTABLE;

exit;

