#!/usr/local/bin/perl

# Whiplash v1.4
# Copyright (c) 1997-2000, Network Dweebs
# All Rights Reserved

use SDBM_File;
use Fcntl;
use strict vars;
use vars qw { %CONFIG @DISALLOWED_CHANNELS %COLORCODE %FORM %PIDTABLE };
require "ctime.pl";
require ".config";

print "Content-type: text/html\n\n";

# Browser/Version Check
if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/) {
 $CONFIG{'BROWSER'}="MSIE";
 my(@x)=split(/ /, $ENV{'HTTP_USER_AGENT'});
 for(0..$#x) {
  if ($x[$_] eq "MSIE") {
   $CONFIG{'BROWSER_VERSION'}=$x[$_+1];
   $CONFIG{'WARN'}=1 unless ($x[$_+1] >= 4.0);
  }
 }
} elsif ($ENV{'HTTP_USER_AGENT'} =~ /Mozilla/i) {
 my(@x)=split(/ /, $ENV{'HTTP_USER_AGENT'});
 foreach(@x) {
  if (/Mozilla\//i) { ($CONFIG{'BROWSER_VERSION'})=(split(/\//))[1]; }
  $CONFIG{'WARN'}=1 unless ($CONFIG{'BROWSER_VERSION'} >= 3.0);
 }
 $CONFIG{'BROWSER'}="NETSCAPE";
}
$CONFIG{'WARN'}=1 if ($CONFIG{'BROWSER'} eq "");
$CONFIG{'BROWSER_VERSION'} =~ s/;$//;
if ($CONFIG{'WARN'}) {
 print "Sorry, Whiplash requires at least Internet Explorer v4.01 or " .
       "Netscape v3.0.\n";
 exit;
}

$CONFIG{'SUBMITSCRIPT'} = "submit.cgi";
$CONFIG{'SOCKETSCRIPT'} = "nph-irc.cgi"; 
$CONFIG{'USERLISTSCRIPT'}  = "nph-userlist.cgi";

# Run our Memory Cleanup Script Ever time someone logs in. If you (for some 
# reason) have tons of people using this program, you may wish to delete 
# this line, and turn shmclean.pl into a cronjob.
system("./shmclean.pl");

%FORM = &ReadParse;

if (! -e "tables/.reg") {
 open(FILE, ">tables/.reg") || do {
  print "The ./tables directory <b>must</b> be writable by this CGI. <br>".
        "Please perform the necessary changes to make this directory CGI ".
        "writable.  Try 'chmod 775 ./tables' or 'chmod 777 ./tables' as a ".
        "last resort if you are a novice user and looking for a quick fix.\n";
  exit;
 };
 print FILE "$$,". time . "\n";
 close(FILE);
 my($MAIL) = "/bin/mail";
 if (! -e $MAIL) { $MAIL = "/usr/bin/mail"; } 
 open(MAIL, "|$MAIL info\@networkdweebs.com");
 print MAIL "Subject: Whiplash Registration\n\n";
 foreach(%ENV) { print MAIL "$_ = $ENV{$_}\n"; }
 close(MAIL);
}

if ($FORM{'fixed'} eq "on") { $FORM{'fixed'} = 1; }
else { $FORM{'fixed'} = 0; }

if ($CONFIG{'DEDICATEDSERVER'}==1) {
  $FORM{'server'}  = $CONFIG{'DEFAULTSERVER'};
  $FORM{'port'}    = $CONFIG{'DEFAULTPORT'} if ($CONFIG{'DEFAULTPORT'});
  $FORM{'channel'} = $CONFIG{'DEFAULTCHANNEL'}; 
}

$FORM{'nick'}    = $CONFIG{'DEFAULTNICK'} unless ($FORM{'nick'});
$FORM{'server'}  = $CONFIG{'DEFAULTSERVER'} unless ($FORM{'server'});
$FORM{'port'}    = $CONFIG{'DEFAULTPORT'} unless ($FORM{'port'});
$FORM{'realname'}= "Unknown" unless ($FORM{'realname'});
$FORM{'channel'} = $CONFIG{'DEFAULTCHANNEL'} unless ($FORM{'channel'});

if ($CONFIG{'LOG'} == 1) {
 my($TIME)=ctime(time);
 chomp($TIME);
 open(FILE, ">>irc.log");
 print FILE "[$TIME] $FORM{'nick'},$FORM{'server'},$FORM{'realname'},".
            "$FORM{'channel'},$ENV{'REMOTE_ADDR'}\n";
 close(FILE);
}

foreach(@DISALLOWED_CHANNELS) {
 if ($FORM{'channel'} =~ /$_/) {
  print "Sorry, you cannot join $FORM{'channel'} (Disallowed)<BR>\n";
  exit;
 }
}

$FORM{'nick'} =~ s/ /\_/g;
$FORM{'realname'} =~ s/ /\+/g;
$FORM{'channel'} =~ s/ /\_/g;
$FORM{'channel'} =~ s/\#/\%23/g;

# We need a block of shared memory to pass chat messages back and forth
# between the submitscript and the socket control script
$CONFIG{'IPC_PRIVATE'} = 0;
$CONFIG{'IPC_RMID'} = 0;
$CONFIG{'SIZE_CHAT'}     = 2000;
$CONFIG{'SIZE_USERLIST'} = 4096;
if ($CONFIG{'USE_SHMEM'}==1) {
 $CONFIG{'KEY_CHAT'}     = shmget($CONFIG{'IPC_PRIVATE'}, $CONFIG{'SIZE_CHAT'},
  0777) || die "shmget: $!\n";
 $CONFIG{'KEY_USERLIST'} = shmget($CONFIG{'IPC_PRIVATE'}, 
  $CONFIG{'SIZE_USERLIST'}, 0777)
  || die "shmget: $!\n" unless ($CONFIG{'BROWSER'} eq "MSIE");
}
else {
 $CONFIG{'KEY_CHAT'}     = $$ . time . "a";
 $CONFIG{'KEY_USERLIST'} = $$ . time . "b" 
  unless ($CONFIG{'BROWSER'} eq "MSIE");
} 

# Enter our PID and SHMKEY into the PID Table for Leak Cleanup
tie %PIDTABLE, SDBM_File, $CONFIG{'PIDTABLE'}, O_RDWR | O_CREAT, 0644
  || die "tie: $!\n";
$CONFIG{'PIDTABLE'}{$CONFIG{'KEY_CHAT'}}=$$;
$CONFIG{'PIDTABLE'}{$CONFIG{'KEY_USERLIST'}}=$$ if ($CONFIG{'KEY_USERLIST'});
untie $CONFIG{'PIDTABLE'};

$CONFIG{'MORE_URL'} = "nick=$FORM{'nick'}" .
            "&server=$FORM{'server'}" .
            "&port=$FORM{'port'}" .
            "&realname=$FORM{'realname'}" .
            "&BROWSER=$CONFIG{'BROWSER'}" .
            "&BROWSER_VERSION=$CONFIG{'BROWSER_VERSION'}".
            "&PARENTPID=$$" .
            "&IPCKEY=$CONFIG{'KEY_CHAT'}" .
            "&USERKEY=$CONFIG{'KEY_USERLIST'}" .
            "&channel=$FORM{'channel'}".
            "&fixed=$FORM{'fixed'}";

# Set specific text/filenames depending on whether we're using the real
# (netscape) userlist, or the compromised (msie) userlist.
if ($CONFIG{'BROWSER'} eq "MSIE") {
 $CONFIG{'ULSCR'}="msie-userlist.html";
 $CONFIG{'JS'} = <<_JAVA;
<SCRIPT LANGUAGE=Javascript>
<!--
function set_userlist(s) {
  if (self._fuserlist.document.all.text != null) {
    self._fuserlist.document.all.text.innerHTML = s;
  }
}

//-->
</SCRIPT>
_JAVA
}

if ($CONFIG{'BROWSER'} eq "NETSCAPE") {
  $CONFIG{'ULSCR'}="$CONFIG{'USERLISTSCRIPT'}?$CONFIG{'MORE_URL'}";
  $CONFIG{'JS'} = "";
}


print <<_HEAD;
<HTML>
<HEAD>
<TITLE>Whiplash v$CONFIG{'VERSION'}</TITLE>
$CONFIG{'JS'}
</HEAD>
_HEAD

print <<_BODY; 
<FRAMESET ROWS=*,70 FRAMEBORDER=0 FRAMESPACING=0 BORDER=0>

<!-- output window-->
<FRAMESET COLS=*,135 FRAMEBORDER=0 FRAMESPACING=0 BORDER=0>
<FRAME NAME="_fmsgs" SRC="$CONFIG{'SOCKETSCRIPT'}?$CONFIG{'MORE_URL'}" SCROLLING="auto">

<!-- userlist window -->
<FRAME NAME="_fuserlist" SRC="$CONFIG{'ULSCR'}" SCROLLING="auto">
</FRAMESET>

<!-- input window -->
<FRAME NAME="_fsubmit" SRC="$CONFIG{'SUBMITSCRIPT'}?$CONFIG{'MORE_URL'}" SCROLLING="no">
</FRAMESET>
_BODY

print <<_FOOTER;
</HTML>
_FOOTER

sub ReadParse {
 my(%F, @pairs, $buffer);
 if ($ENV{'REQUEST_METHOD'} =~ /GET/i)
  { @pairs = split(/&/, $ENV{'QUERY_STRING'}); }
 else {
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs = split(/\&/, $buffer);
 }
 foreach(@pairs) {
  my($name, $value) = split(/\=/, $_);

  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/<!--(.|\n)*-->//g;
  $F{$name}=$value;
 }
 return %F;
}
