#!/usr/local/bin/perl

# Whiplash v1.4
# Copyright (c) 197-2000, Network Dweebs
# All Rights Reserved
#
# This source code may be freely distributed for educational purposes,
# and may not be used for profit.  All uses of this software require
# the author's original Copyright and credit information to remain in
# the source code, and displayed to the client. 

use SDBM_File;
use Fcntl;
use strict vars;
use vars qw { %CONFIG @DISALLOWED_HANDLES %COLORCODE $DEBUG $IPC_RMID 
              $PID $KEY %PIDTABLE };
require ".config";

$DEBUG = 0;
$IPC_RMID = 0;

tie %PIDTABLE, SDBM_File, $CONFIG{'PIDTABLE'}, O_RDWR | O_CREAT, 0644;
foreach $KEY (keys(%PIDTABLE)) {
  $PID = $PIDTABLE{$KEY};
  $DEBUG && print "Examining PID $PID ($KEY)\n";
  if (!(kill 0, $PID)) {
    if ($CONFIG{'USE_SHMEM'}==1) { shmctl($KEY, $IPC_RMID, 0); }
      else { unlink("$CONFIG{'MEMDIR'}/$KEY"); }
    delete($PIDTABLE{$KEY});
    $DEBUG && print "Deleted Shared Key $KEY ($PID)\n";
  } 
  else {
    $DEBUG && print "PID $PID Still alive.  Not removing Shared Key.\n";
  }
}
untie %PIDTABLE;


